/* This code is distributed under the terms of Gnu Publice License */
/* The author is Przemek Borys <pborys@dione.ids.pl> */
/* Modifications by Stefan Weinzierl */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "eqascii.h"

int
eqascii (const char *equation, int textwidth)
{
  struct Tgraph *graph=malloc(sizeof(struct Tgraph));
  char **screen;
  int i, j, k;
  int textlines;

  graph->up = 0;
  graph->down = 0;
  graph->children = 0;
  dim (preparse (equation), graph);
  screen = draw (graph);

  textlines = (graph->dim.x)/textwidth;

  for (k = 0; k < textlines; k++)
    {
      for (i = 0; i < graph->dim.y; i++)
	{
	  for (j = 0; j < textwidth; j++)
	    printf ("%c", screen[i][j+k*textwidth]);
	  printf ("\n");
	}
      printf ("\n");
    }

  for (i = 0; i < graph->dim.y; i++)
    {
      for (j = textlines*textwidth; j < graph->dim.x; j++)
	printf ("%c", screen[i][j]);
      printf ("\n");
    }

  dealloc(graph); 
  return 0;
}
