#! /usr/bin/perl -w

undef $/;

foreach $file (@ARGV) {
 
    my $tmpfile;
    $tmpfile = "tmp${file}tmp";

    open (INPUT,"<$file") or die "Can't open input file $file\n";
    open (TMPFILE, "> $tmpfile") or die "Can't open temporary file: $!\n";

    # Read input file as one long record 
    $data=<INPUT>;

    # replace
    #   // not gTybalt
    # with
    #   #ifndef __MAKECINT__
    # and replace
    #   // end not gTybalt
    # with
    #   #endif
#    $data =~ s/(.*?\/\/ not gTybalt.*?\n)/\#ifndef __MAKECINT__\n/g;
#    $data =~ s/(.*?\/\/ end not gTybalt.*?\n)/\#endif\n/g;


    # replace
    #   // gTybalt
    # with
    #   #ifdef __MAKECINT__
    # and replace
    #   // end gTybalt
    # with
    #   #endif
#    $data =~ s/(.*?\/\/ gTybalt.*?\n)/\#ifdef __MAKECINT__\n/g;
#    $data =~ s/(.*?\/\/ end gTybalt.*?\n)/\#endif\n/g;


    # replace 
    #
    #   #include <cln/complex.h>
    #
    # with
    #
    #   #ifdef __MAKECINT__
    #   namespace cln { class cl_number; }
    #   namespace cln { class cl_N; }
    #   #endif
    #   #ifndef __MAKECINT__
    #   #include <cln/complex.h>
    #   #endif
    #
#    $data =~ s/\#include \<cln\/complex\.h\>/\#ifdef __MAKECINT__\nnamespace cln { class cl_number; }\nnamespace cln { class cl_N; }\n\#endif\n\#ifndef __MAKECINT__\n\#include \<cln\/complex\.h\>\n\#endif/g;


    # entry point for (pseudo)-functions in GiNaC
    #
    # replace
    #     const GiNaC::function NAME(...
    # with
    #     GiNaC::ex NAME(
    #
    # and replace
    #     return GiNaC::function(   )
    # with
    #     return GiNaC::function(   ).eval()
    #
#    $data =~ s/const GiNaC\:\:function/GiNaC\:\:ex/g;
#    $data =~ s/(return GiNaC\:\:function.*?)\;/$1\.eval\(\)\;/g;

    # for zeta and psi
#    $data =~ s/inline function/inline ex/g;
#    $data =~ s/(return function.*?)\;/$1\.eval\(\)\;/g;


    # replace (in print.h)
    #
    #     std::ostream & s;
    #
    # with
    #
    #   #ifndef __MAKECINT__
    #     std::ostream & s;
    #   #endif
    #
    # reference to ostream not liked by CINT.
    # CINT issues the following warning:
    # Limitation: Reference member not accessible from the interpreter
#    $data =~ s/\n(.*?std\:\:ostream \& s.*?\n)/\n\#ifndef __MAKECINT__\n$1\#endif\n/g;


    # wild() --> wildcard(0)
    #
#    $data =~ s/wild\(\)/wildcard\(0\)/g;


    # replace
    #   template<> inline ...
    #   {
    #   	...
    #   }
    # with
    #   #ifndef __MAKECINT__
    #   template<> inline ...
    #   {
    #   	...
    #   }
    #   #endif
#    $data =~ s/\n(.*?template\<\> inline.*?\n\{.*?\n.*?\n\}.*?\n)/\n\#ifndef __MAKECINT__\n$1\#endif\n/g;


    print TMPFILE $data;

    close INPUT;
    close TMPFILE;
    rename $tmpfile, $file;

} # end foreach

exit(0);

