//
// convenience.cc
//

/*
 *  gTybalt Copyright (C) 2011 Stefan Weinzierl and Roberta Marani
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "convenience.h"

using namespace GiNaC;

// ----------------------------------------------

bool is_a_symbol(const ex & arg)
{
  return is_a<symbol>(arg);
}

bool is_exactly_a_symbol(const ex & arg)
{
  return is_exactly_a<symbol>(arg);
}

const symbol & ex_to_symbol(const ex & arg)
{
  return ex_to<symbol>(arg);
}

// ----------------------------------------------

bool is_a_constant(const ex & arg)
{
  return is_a<constant>(arg);
}

bool is_exactly_a_constant(const ex & arg)
{
  return is_exactly_a<constant>(arg);
}

const constant & ex_to_constant(const ex & arg)
{
  return ex_to<constant>(arg);
}

// ----------------------------------------------

bool is_a_numeric(const ex & arg)
{
  return is_a<numeric>(arg);
}

bool is_exactly_a_numeric(const ex & arg)
{
  return is_exactly_a<numeric>(arg);
}

const numeric & ex_to_numeric(const ex & arg)
{
  return ex_to<numeric>(arg);
}

// ----------------------------------------------

bool is_a_wildcard(const ex & arg)
{
  return is_a<wildcard>(arg);
}

bool is_exactly_a_wildcard(const ex & arg)
{
  return is_exactly_a<wildcard>(arg);
}

const wildcard & ex_to_wildcard(const ex & arg)
{
  return ex_to<wildcard>(arg);
}

// ----------------------------------------------

bool is_a_matrix(const ex & arg)
{
  return is_a<matrix>(arg);
}

bool is_exactly_a_matrix(const ex & arg)
{
  return is_exactly_a<matrix>(arg);
}

const matrix & ex_to_matrix(const ex & arg)
{
  return ex_to<matrix>(arg);
}

// ----------------------------------------------

bool is_a_relational(const ex & arg)
{
  return is_a<relational>(arg);
}

bool is_exactly_a_relational(const ex & arg)
{
  return is_exactly_a<relational>(arg);
}

const relational & ex_to_relational(const ex & arg)
{
  return ex_to<relational>(arg);
}

// ----------------------------------------------

bool is_a_tensor(const ex & arg)
{
  return is_a<tensor>(arg);
}

bool is_exactly_a_tensor(const ex & arg)
{
  return is_exactly_a<tensor>(arg);
}

const tensor & ex_to_tensor(const ex & arg)
{
  return ex_to<tensor>(arg);
}

// ----------------------------------------------

bool is_a_tensdelta(const ex & arg)
{
  return is_a<tensdelta>(arg);
}

bool is_exactly_a_tensdelta(const ex & arg)
{
  return is_exactly_a<tensdelta>(arg);
}

const tensdelta & ex_to_tensdelta(const ex & arg)
{
  return ex_to<tensdelta>(arg);
}

// ----------------------------------------------

bool is_a_idx(const ex & arg)
{
  return is_a<idx>(arg);
}

bool is_exactly_a_idx(const ex & arg)
{
  return is_exactly_a<idx>(arg);
}

const idx & ex_to_idx(const ex & arg)
{
  return ex_to<idx>(arg);
}

// ----------------------------------------------

bool is_a_varidx(const ex & arg)
{
  return is_a<varidx>(arg);
}

bool is_exactly_a_varidx(const ex & arg)
{
  return is_exactly_a<varidx>(arg);
}

const varidx & ex_to_varidx(const ex & arg)
{
  return ex_to<varidx>(arg);
}

// ----------------------------------------------

bool is_a_lst(const ex & arg)
{
  return is_a<lst>(arg);
}

bool is_exactly_a_lst(const ex & arg)
{
  return is_exactly_a<lst>(arg);
}

const lst & ex_to_lst(const ex & arg)
{
  return ex_to<lst>(arg);
}

// ----------------------------------------------

bool is_a_indexed(const ex & arg)
{
  return is_a<indexed>(arg);
}

bool is_exactly_a_indexed(const ex & arg)
{
  return is_exactly_a<indexed>(arg);
}

const indexed & ex_to_indexed(const ex & arg)
{
  return ex_to<indexed>(arg);
}

// ----------------------------------------------

bool is_a_clifford(const ex & arg)
{
  return is_a<clifford>(arg);
}

bool is_exactly_a_clifford(const ex & arg)
{
  return is_exactly_a<clifford>(arg);
}

const clifford & ex_to_clifford(const ex & arg)
{
  return ex_to<clifford>(arg);
}

// ----------------------------------------------

bool is_a_color(const ex & arg)
{
  return is_a<color>(arg);
}

bool is_exactly_a_color(const ex & arg)
{
  return is_exactly_a<color>(arg);
}

const color & ex_to_color(const ex & arg)
{
  return ex_to<color>(arg);
}

// ----------------------------------------------

bool is_a_function(const ex & arg)
{
  return is_a<function>(arg);
}

bool is_exactly_a_function(const ex & arg)
{
  return is_exactly_a<function>(arg);
}

const function & ex_to_function(const ex & arg)
{
  return ex_to<function>(arg);
}

// ----------------------------------------------

bool is_a_fderivative(const ex & arg)
{
  return is_a<fderivative>(arg);
}

bool is_exactly_a_fderivative(const ex & arg)
{
  return is_exactly_a<fderivative>(arg);
}

const fderivative & ex_to_fderivative(const ex & arg)
{
  return ex_to<fderivative>(arg);
}

// ----------------------------------------------

bool is_a_ncmul(const ex & arg)
{
  return is_a<ncmul>(arg);
}

bool is_exactly_a_ncmul(const ex & arg)
{
  return is_exactly_a<ncmul>(arg);
}

const ncmul & ex_to_ncmul(const ex & arg)
{
  return ex_to<ncmul>(arg);
}

// ----------------------------------------------

bool is_a_pseries(const ex & arg)
{
  return is_a<pseries>(arg);
}

bool is_exactly_a_pseries(const ex & arg)
{
  return is_exactly_a<pseries>(arg);
}

const pseries & ex_to_pseries(const ex & arg)
{
  return ex_to<pseries>(arg);
}

// ----------------------------------------------

bool is_a_power(const ex & arg)
{
  return is_a<power>(arg);
}

bool is_exactly_a_power(const ex & arg)
{
  return is_exactly_a<power>(arg);
}

const power & ex_to_power(const ex & arg)
{
  return ex_to<power>(arg);
}

// ----------------------------------------------

bool is_a_mul(const ex & arg)
{
  return is_a<mul>(arg);
}

bool is_exactly_a_mul(const ex & arg)
{
  return is_exactly_a<mul>(arg);
}

const mul & ex_to_mul(const ex & arg)
{
  return ex_to<mul>(arg);
}

// ----------------------------------------------

bool is_a_add(const ex & arg)
{
  return is_a<add>(arg);
}

bool is_exactly_a_add(const ex & arg)
{
  return is_exactly_a<add>(arg);
}

const add & ex_to_add(const ex & arg)
{
  return ex_to<add>(arg);
}

