//
// factor.h
//
// A function to factorize a univariate polynomial with integer coefficients
// ex factorpoly( const ex &PolyIn, const symbol &x )
//
/*
 *  gTybalt Copyright (C) 2001 Roberta Marani and Stefan Weinzierl 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __GTYBALT_FACTOR_H__
#define __GTYBALT_FACTOR_H__

#if !defined(__CINT__)
#include "ginac/ginac.h"
#else
#include "../ginac_headers/ginac.h"
#endif

#if !defined(__CINT__)
#include "NTL/ZZXFactoring.h"
#endif

GiNaC::ex factorpoly( const GiNaC::ex &PolyIn, const GiNaC::symbol &x );

#if !defined(__CINT__)
void ZZFromNumeric(NTL::ZZ& zx, GiNaC::numeric& nx);
void NumericFromZZ(GiNaC::numeric& nx, NTL::ZZ& zx);
#endif

#endif // ndef __GTYBALT_FACTOR_H__
