//
// globals.h
//

/*
 *  gTybalt Copyright (C) 2001 Stefan Weinzierl and Roberta Marani
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __GTYBALT_GLOBALS_H__
#define __GTYBALT_GLOBALS_H__

#if !defined(__CINT__)
#include "ginac/ginac.h"
#else
#include "../ginac_headers/ginac.h"
#endif

#include <cstddef>

#include "version.h"

const int gTybalt_version_major = TYBALT_MAJOR;
const int gTybalt_version_minor = TYBALT_MINOR;
const int gTybalt_version_micro = TYBALT_MICRO;

// gGinacTexmacs for output format prettyprint/rawprint
extern int gGinacTexmacs;

// global variables needed for the plotting routine
extern GiNaC::ex gTybaltPlotExpr;
extern GiNaC::ex gTybaltPlotSymbol_x;
extern GiNaC::ex gTybaltPlotSymbol_y;

extern double gTybaltPlot_xmin;
extern double gTybaltPlot_xmax;
extern double gTybaltPlot_ymin;
extern double gTybaltPlot_ymax;

#if !defined(__CINT__)
#include <pthread.h>
extern int gTybalt_pthread_flag;
extern pthread_mutex_t gTybalt_pthread_mutex;
extern pthread_cond_t  gTybalt_pthread_condition;
#endif

// global variables needed for the numerical integration routine
extern double gTybalt_int_res;
extern double gTybalt_int_err;
extern double gTybalt_int_chi2;

extern size_t gTybalt_int_iter_low;
extern size_t gTybalt_int_iter_high;

extern size_t gTybalt_int_calls_low;
extern size_t gTybalt_int_calls_high;

#endif // ndef __GTYBALT_GLOBALS_H__
