//
// integrate.h
//

/*
 *  gTybalt Copyright (C) 2003 Stefan Weinzierl and Roberta Marani
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __GTYBALT_INTEGRATE_H__
#define __GTYBALT_INTEGRATE_H__

#if !defined(__CINT__)
#include "ginac/ginac.h"
#else
#include "../ginac_headers/ginac.h"
#endif

#include <cstddef>
#include <string>

double intnum(GiNaC::ex expr, GiNaC::ex x, double xmin, double xmax);
double intnum(GiNaC::ex expr, GiNaC::ex x, GiNaC::ex y, 
	                   double xmin, double xmax,
                           double ymin, double ymax);
double intnum(GiNaC::ex expr, GiNaC::lst x, GiNaC::lst xmin, GiNaC::lst xmax);

double intnum_imp(GiNaC::ex expr, size_t dimension, 
		  double *xmin, double *xmax);

std::string gtybalt_itos(int arg);

#endif // ndef __GTYBALT_INTEGRATE_H__
