//
// routines.cc
//

/*
 *  gTybalt Copyright (C) 2001 Stefan Weinzierl and Roberta Marani
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <iostream>
#include <cstdio>

#include "routines.h"

#include "config.h"

extern int gGinacTexmacs;

#define DATA_BEGIN  ((char) 2)
#define DATA_END    ((char) 5)
#define DATA_ESCAPE ((char) 27)

// ---------------------------------------------
void greeting()
{
  if (gGinacTexmacs==1)
    {
      std::cout << DATA_BEGIN << "verbatim:";
    }

  std::cout << "\n";
  std::cout << "Welcome to gTybalt (version " << VERSION << ") \n";
  std::cout << "\n";

  std::cout << "Copyright (C) 2001-2020 Stefan Weinzierl and Roberta Marani \n";
  std::cout << "This is free software with ABSOLUTELY NO WARRANTY. \n";
  std::cout << "You are welcome to redistribute it under certain conditions. \n";
  std::cout << "For details type `warranty()'. \n";
  std::cout << "\n";
 
  std::cout << "gTybalt is build on top of other packages, for more information \n";
  std::cout << "type `credits()`. \n";
  std::cout << "\n";

  if (gGinacTexmacs==1)
    {
      std::cout << DATA_END;
      fflush (stdout);
    }
}

// ---------------------------------------------
void warranty()
{
  std::cout << "\n";
  std::cout << "This program is free software; you can redistribute it and/or modify it under \n";
  std::cout << "the terms of the GNU General Public License as published by the Free Software \n";
  std::cout << "Foundation; either version 2 of the License, or (at your option) any later \n";
  std::cout << "version. \n";
  std::cout << "This program is distributed in the hope that it will be useful, but WITHOUT \n";
  std::cout << "ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS \n";
  std::cout << "FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more \n";
  std::cout << "details. \n";
  std::cout << "You should have received a copy of the GNU General Public License along with \n";
  std::cout << "this program. If not, write to the Free Software Foundation, 675 Mass Ave, \n";
  std::cout << "Cambridge, MA 02139, USA. \n";    
  std::cout << "\n";
}

// ---------------------------------------------
void credits()
{
  std::cout << "\n";
  std::cout << "gTybalt is build on top of several other packages: \n";
  std::cout << "\n";
  std::cout << "- GiNaC by Christian Bauer, Alexander Frink und Richard Kreckel \n";
  std::cout << "        for algebraic manipulations; \n";
  std::cout << "- TeXmacs by Joris van der Hoeven as editor; \n";
  std::cout << "- CINT by Masaharu Goto as a C++/C interpreter; \n";
  std::cout << "- Root by Rene Brun and Fons Rademakers for plots \n";
  std::cout << "        and graphics; \n";
  std::cout << "- CLN library by Bruno Haible for large numbers; \n";
  std::cout << "- Eqascii by Przemek Borys for pretty print output in text mode; \n";
  std::cout << "- GNU Scientific Library by Mark Galassi, Jim Davies, James Theiler, \n";
  std::cout << "        Brian Gough, Gerard Jungman, Michael Booth and Fabrice Rossi \n";
  std::cout << "        for Monte Carlo integration. \n";
  std::cout << "\n";
  std::cout << "Optionally gTybalt can be compiled with: \n";
  std::cout << "\n";
  std::cout << "- NTL library by Victor Shoup for factorization of polynomials; \n";
  std::cout << "- Nestedsums library by S.W. for the expansion of transcendental functions. \n";
  std::cout << "\n";
}

