//
// threads.cc
//

/*
 *  gTybalt Copyright (C) 2001 Stefan Weinzierl and Roberta Marani
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "threads.h"
#include "globals.h"
#include "plot.h"

void* gTybalt_pthread_fct(void* arg)
{
  while (1) {
    pthread_mutex_lock(&gTybalt_pthread_mutex);
    while (!gTybalt_pthread_flag) 
      pthread_cond_wait(&gTybalt_pthread_condition, &gTybalt_pthread_mutex);

    if ( gTybalt_pthread_flag == 1)
      {
	plot_1d_imp();
      }
    else if ( gTybalt_pthread_flag == 2)
      {
	plot_2d_imp();
      }
    else if ( gTybalt_pthread_flag == -1)
      {
	pthread_exit(0);
      }
    else
      {
	pthread_exit(0);
      }

    gTybalt_pthread_flag = 0;
    pthread_mutex_unlock(&gTybalt_pthread_mutex);
  }
  return NULL;
}

void initialize_gTybalt_pthread_condition(void)
{
  pthread_mutex_init(&gTybalt_pthread_mutex,NULL);
  pthread_cond_init(&gTybalt_pthread_condition,NULL);
  gTybalt_pthread_flag = 0;
}

void set_gTybalt_pthread_flag(int flag_value)
{
  pthread_mutex_lock(&gTybalt_pthread_mutex);
  gTybalt_pthread_flag = flag_value;
  pthread_cond_signal(&gTybalt_pthread_condition);
  pthread_mutex_unlock(&gTybalt_pthread_mutex);
}

void cancel_gTybalt_pthread(void)
{
  set_gTybalt_pthread_flag(-1);
}

